import { FederationRuntimePlugin } from '@module-federation/enhanced/runtime';
import { FrontendFeatureLoader } from '@backstage/frontend-plugin-api';
import { UserOptions, ShareStrategy } from '@module-federation/runtime/types';

/**
 *
 * @public
 */
type DynamicFrontendFeaturesLoaderOptions = {
    /**
     * Additional module federation arguments for the Module Federation runtime initialization.
     */
    moduleFederation: {
        shared?: UserOptions['shared'];
        shareStrategy?: ShareStrategy;
        plugins?: Array<FederationRuntimePlugin>;
    };
};
/**
 * A function providing a loader of frontend features exposed as module federation remotes
 * from the backend dynamic features service.
 *
 * @public
 */
declare function dynamicFrontendFeaturesLoader(options?: DynamicFrontendFeaturesLoaderOptions): FrontendFeatureLoader;

export { type DynamicFrontendFeaturesLoaderOptions, dynamicFrontendFeaturesLoader };
